;
; LOD Player Version 2
;
; 1Cf2
; 1D8f
;
F1LO	= $FF0E
F1HI	= $FF12
F2LO	= $FF0F
F2HI	= $FF10

OFF	= $3F
	
; COMMAND BYTES

END_MARK	= $FE
SET_VOLTAB	= $FF
SET_ARP		= $FD
CLICK		= $FC
VOL_UP		= $FB
SETINS		= $F0
SETLEN		= $40

; Constants
base_note = -10 ; shift to Ai0
C0	= base_note + 0
Ci0	= base_note + 1
D0	= base_note + 2
Di0	= base_note + 3
E0	= base_note + 4
F0	= base_note + 5
Fi0	= base_note + 6
G0	= base_note + 7
Gi0	= base_note + 8
A0	= base_note + 9
Ai0	= base_note + 10
B0	= base_note + 11

C1	= base_note + 12
Ci1	= base_note + 13
D1	= base_note + 14
Di1	= base_note + 15
E1	= base_note + 16
F1	= base_note + 17
Fi1	= base_note + 18
G1	= base_note + 19
Gi1	= base_note + 20
A1	= base_note + 21
Ai1	= base_note + 22
B1	= base_note + 23

C2	= base_note + 24
Ci2	= base_note + 25
D2	= base_note + 26
Di2	= base_note + 27
E2	= base_note + 28
F2	= base_note + 29
Fi2	= base_note + 30
G2	= base_note + 31
Gi2	= base_note + 32
A2	= base_note + 33
Ai2	= base_note + 34
B2	= base_note + 35

C3	= base_note + 36
Ci3	= base_note + 37
D3	= base_note + 38
Di3	= base_note + 39
E3	= base_note + 40
F3	= base_note + 41
Fi3	= base_note + 42
G3	= base_note + 43
Gi3	= base_note + 44
A3	= base_note + 45
Ai3	= base_note + 46
B3	= base_note + 47

C4	= base_note + 48
Ci4	= base_note + 49
D4	= base_note + 50
Di4	= base_note + 51
E4	= base_note + 52
F4	= base_note + 53
Fi4	= base_note + 54
G4	= base_note + 55
Gi4	= base_note + 56
A4	= base_note + 57
Ai4	= base_note + 58
B4	= base_note + 59

C5	= base_note + 60
Ci5	= base_note + 61
D5	= base_note + 62

;-----
          
	;ALIGN 256
PLAYER_FREQ_INIT
	JMP PLAYER_FREQ_INIT_ACTUAL
PLAYER
	JMP PLAYER_ACTUAL
	
PLAYER_FREQ_INIT_ACTUAL
	;         
	; *** Freq init
	;
	LDX #(Channel1 - OFS) & 255
	LDY #(Channel1 - OFS) >> 8
	STX PCH1_LO
	STY PCH1_HI
	;
	LDX #(Channel2 - OFS) & 255
	LDY #(Channel2 - OFS) >> 8
	STX PCH2_LO
	STY PCH2_HI
	;
	LDX #(Channel3 - OFS) & 255
	LDY #(Channel3 - OFS) >> 8
	STX PCH3_LO
	STY PCH3_HI
	;
	LDX #$FF
	STX VOLTAB_CNT
	INX       
	STX NOTE1
	STX NOTE2
	STX NOTE3
	JSR res - OFS
	INX
	STX NOTELEN1
	STX NOTELEN2
	STX NOTELEN3
	JSR res - OFS
	INX		; x=2
	JSR res - OFS
	;
	LDA #9*0
	STA VOLUME
	;
	RTS

res	LDY #$00
	DB $2C
	
advance	LDY PCH1,X
	;      
	LDA PCH1_LO,x
	STA PCH_TEMP
	LDA PCH1_HI,x
	STA PCH_TEMP+1
	;
	LDA (PCH_TEMP),y	; LO byte
	STA CH1_LO,X
	INY
	LDA (PCH_TEMP),y	; HI byte
	BEQ res
	STA CH1_HI,X
	INY
	STY PCH1,X
	RTS
	
	;
	;##################
	;

PLAYER_ACTUAL
	LDX #$02
	;
channel_loop
	INC NOTE1,x
	;
	LDA NOTE1,x
	CMP NOTELEN1,x
	BEQ next_note
	JMP channel_loop_end-OFS
	;
next_note 
	LDA CH1_LO,x
	STA CH_TEMP
	LDA CH1_HI,x
	STA CH_TEMP+1
	;
	LDY #$00
	STY NOTE1,x		; reset note counter
	;   
	LDA (CH_TEMP),y		; get byte
	INY
	;
	CMP #END_MARK		; $FF goes to new pattern
	BNE pl_10
	;
	JSR advance - OFS
	BNE next_note		; should never be zero
	;
pl_10	CMP #SET_VOLTAB
	BNE pl_12
	;
	STA VOLTAB_CNT
	;
	LDA (CH_TEMP),y		; get lo byte
	INY
	STA VOL_TAB - OFS+1
	;
	LDA (CH_TEMP),y		; get byte
	INY
	;
pl_12	CMP #SET_ARP		; instrument change?
	BNE pl_13
	;
	LDA (CH_TEMP),y		; get arpeggio byte
	AND #$0F
	STA arpeggio+1-OFS
	;
	LDA (CH_TEMP),y		; get same byte again
	LSR a
	LSR a
	LSR a
	LSR a
	STA arpeggio+2-OFS
	BEQ arp2v
	;
	LDA #$06
	DB $2C
arp2v	LDA #$04
	STA arplen+1
	;
	INY
	;
	LDA (CH_TEMP),y		; get byte
	INY
	;
pl_13	CMP #CLICK
	BNE pl_14
	;
	LDA $FF11
	ORA #$80
	STA $FF11
	;
	LDA (CH_TEMP),y		; get byte
	INY
	;
pl_14	CMP #VOL_UP
	BNE pl_15
	;
	LDA VOLUME
	BEQ vol_at_max
	;
	SEC
	SBC #$09
	STA VOLUME
	;
vol_at_max
	LDA (CH_TEMP),y		; get byte
	INY
	;
pl_15	CMP #$FA
	BNE pl_11
	;
	DEC $FF19
	;
	LDA (CH_TEMP),y		; get byte
	INY
	;
pl_11	CMP #SETINS		; instrument change?
	BCC pl_01
	;
	AND #$0F		; keep lower 4 bits
	STA INS_TYPE1,x   	; store instrument type
	;
	LDA (CH_TEMP),y		; get byte
	INY
	;
pl_01	CMP #SETLEN		; set note length?
	BCC pl_02
	;
	;SEC			; we know carry is always set
	SBC #$40
	STA NOTELEN1,x
	;
	LDA (CH_TEMP),y
	INY
	;
pl_02	; - store note!
	;
	STA TONE1,x
	;
	; --- advance pointer
	;
	TYA
	CLC
	ADC CH1_LO,x
	STA CH1_LO,x
	BCC noi_1
	INC CH1_HI,x
noi_1	;
	;
	; -----------------------------------------------------------------
	;
channel_loop_end
	DEX
	BMI pl_50
	JMP channel_loop-OFS
	;    
pl_50	
	;
	; --- SOUND PROCESSING
	;
PLAYER_SOUND
	LDA #$20
	STA NOISE
	;
	LDX #$02		; channel 3
	JSR sound - OFS
	;
	CMP #$FE
	BNE do_ch2
	;
	LDX #$01		; channel 2
	JSR sound - OFS
	;
do_ch2	STA F1LO_store - OFS+1
	STY F1HI_x - OFS+1
	;
	LDA F1HI
	AND #$FC
F1HI_x	ORA #$00
	STA F1HI_store - OFS+1
	;
	LDX #$00		; channel 1
	JSR sound - OFS
	STA F2LO
	STY F2HI
	;
F1LO_store
	LDA #$00
	STA F1LO
F1HI_store
	LDA #$00
	STA F1HI
	;
	; ---
	;
	LDY VOLTAB_CNT
	INY
res_v	
VOL_TAB	LDA vol_default - OFS,y
	BPL noi_v		; check for $FF
	LDY #$00		; reached, so warp
	BEQ res_v
noi_v	STY VOLTAB_CNT
	CLC
	ADC VOLUME
	TAY
	LDA volume_map - OFS,y
	ORA NOISE
	;
	LDY F1LO
	CPY #$FE
	BNE setvol		; not silent
	LDY F2LO
	CPY #$FE
	BEQ sil			; silent: skip setting $FF11 to avoid clicks
	;
setvol	STA $FF11		; self-mod
	;
sil	RTS     
	;
inst_table
	DW normal - OFS, snare2 - OFS, snare - OFS, blipp - OFS, arp - OFS
	;
sound	LDA TONE1,x
	CMP #OFF
	BEQ lookup
	;
	LDA INS_TYPE1,x
	ASL a
	TAY
	LDA inst_table - OFS,y
	STA inst_jump - OFS+1
	LDA inst_table - OFS+1,y
	STA inst_jump - OFS+2
	;
inst_jump
	JMP $0000
	
normal	LDA TONE1,x		; normal note
lookup	ASL a
	TAX
	LDA freqs,x
	LDY freqs+1,x
	RTS
	
blipp2	LDA TONE1,x
	LDY NOTE1,x
	BEQ lookup
	LDA #OFF
	BNE lookup
	
blipp	LDA TONE1,x
	LDY NOTE1,x
	BEQ lookup
	
	CPY #$02
	BCS blipp_off
	
	CLC
	ADC #$0C
	BNE lookup
	
blipp_off
	LDA #OFF
	BNE lookup
	;
arp	LDA ARP_CNT		; load current arp counter
	CLC
	ADC #$01
arplen	CMP #$06		; auto reset every 6 frames (n1,n1,n2,n2,n3,n3)
	BNE *+4
	LDA #$00
	STA ARP_CNT
	LSR a
	TAY
	LDA arpeggio - OFS,y	; for channel 2 (self-mod)
	CLC
	ADC TONE1,x
	BNE lookup

snare2	
	LDA TONE1,x		; look up note freq
	ASL a
	TAY
	;
	LDA NOTE1,x
	TAX
	LDA snare2_freq - OFS,x	; 16 bit add: add snare freq
	BNE snare1
snare	
	LDA TONE1,x		; look up note freq
	ASL a
	TAY
	;
	LDA NOTE1,x
	TAX
	LDA snare_freq - OFS,x	; 16 bit add: add snare freq
snare1	CLC        
	ADC freqs,y       
	PHA
	LDA freqs+1,y
	TAY
	;
	LDA #$40		; turn on noise bit
	STA NOISE
	;
	PLA
	RTS
;[eof]